( function($) {
    $(document).ready(function() {
      var windowWidth = $(window).width();
      var windowHeight = $(window).height();
      var bookWidth = 0;
      var bookHeight = 0;
      var ratio = 0;
      var totalPages = $('.tx-flipbook .pageContainer').children('.b-page').length - 2;

      $(window).bind('load', function() {
        // get the image ratio
        ratio = ($('.tx-flipbook .b-page img').first().width() / $('.tx-flipbook .b-page img').first().height());
        // init the book to match the parten sizes/ratio*2
        init();
        if (windowWidth > 800) {
          $('.no-touch .pageContainer').booklet('option', {
            arrows : true
          });
          $('.touch .pageContainer').booklet('option', {
            arrows : false
          });
        } else {
          $('.touch .pageContainer').booklet('option', {
            arrows : false
          });
          $('.no-touch .pageContainer').booklet('option', {
            arrows : false
          });
        }
        // singlezoom
        if ($('.bookContainer').hasClass('singleZoomActive') == true && windowWidth < 800) {
          $('.pageContainer').on('click', '.b-page', function(e) { $
            if ($(this).closest('.tx-flipbook').parent().hasClass('flipbookSinglePage')) {
              singleZoom($(this));
            }
          });
        }
      });
      // close zoom
      $('.tx-flipbook .buttons .close').click(function() {
        $(this).closest('.tx-flipbook').parent().removeClass('flipbookZoom flipbookSinglePage flipbookDoublePage flipbookPageIndex');
        $('html').removeClass('flipbookIsZoomed');
        flipBookZoom(windowWidth, windowHeight);
      });
      // open zoom
      $('.tx-flipbook .buttons .flipbookZoom').on('click', function() {
        $(this).closest('.tx-flipbook').parent().addClass('flipbookZoom');
        $('html').addClass('flipbookIsZoomed');
      });
      // show single page
      $('.tx-flipbook .buttons .singlePageLink').click(function() {
        $(this).closest('.tx-flipbook').parent().addClass('flipbookSinglePage');
        $(this).closest('.tx-flipbook').parent().removeClass('flipbookDoublePage flipbookPageIndex');
        flipBookZoom(windowWidth, windowHeight);
        $(window).resize();
        setTimeout(function() {
          var pageHash = window.location.hash;
          var hashNumber = pageHash.match(/[0-9 -()+]+$/);
          singlePageMove(parseInt(hashNumber[0]) - 1, 1);
        }, 1000);
      });
      // show single page
      $('.tx-flipbook .buttons .singlePagePdf').click(function() {
          var pageHash = window.location.hash;
          var hashNumber = pageHash.match(/[0-9 -()+]+$/);
	  file_path=$(this).attr('data-href');
	  file_target=$(this).attr('data-target');
	  page_number = (parseInt(hashNumber[0]) - 1);
	  if( file_target=='' || file_target=='self' ) {
              window.location.href = file_path + "#page=" + page_number;
	  } else {
	      window.open(file_path + "#page=" + page_number, file_target);   
	  }
      });
      // show double page
      $('.tx-flipbook .buttons .doublePage').click(function() {
        $(this).closest('.tx-flipbook').parent().addClass('flipbookDoublePage');
        $(this).closest('.tx-flipbook').parent().removeClass('flipbookSinglePage flipbookPageIndex');
        $(window).resize();
      });
      // show index
      $('.tx-flipbook .buttons .pageIndex').click(function() {
        $(this).closest('.tx-flipbook').parent().toggleClass('flipbookPageIndex');
        if (!$(this).closest('.tx-flipbook').parent().hasClass('flipbookSinglePage') && !$(this).closest('.tx-flipbook').parent().hasClass('flipbookDoublePage')) {
          $(this).closest('.tx-flipbook').parent().addClass('flipbookDoublePage');
        }
        flipBookZoom(windowWidth, windowHeight);
        $(window).resize();
      });
      // if clicked on a thum in the index
      $('.tx-flipbook .thumbContainer .thumb').on('click', function() {
        $('.b-page div div').removeClass('singleZoom');
        $(this).closest('.tx-flipbook').parent().removeClass('flipbookPageIndex');
        if (!$(this).closest('.tx-flipbook').parent().hasClass('flipbookSinglePage')) {
          $(this).closest('.tx-flipbook').parent().addClass('flipbookDoublePage')
        }
        page = parseInt($(this).attr('data-page'))
        if (parseInt($(this).attr('data-page')) % 2 === 0) {
          page++;
        }
        window.location.hash = "/page/" + page;

        if ($(this).closest('.tx-flipbook').parent().hasClass('flipbookDoublePage')) {
          $('.booklet').booklet('gotopage', page);
        } else {
          singlePageMove(parseInt($(this).attr('data-page')), 0);
        }
      });

      $(window).smartresize(function() {
        windowWidth = $(window).width();
        windowHeight = $(window).height();
        // set to fullScreen or to element width
        if ($('.tx-flipbook').parent().hasClass('flipbookZoom')) {
          flipBookZoom(windowWidth, windowHeight);
        } else {
          init();
        }
        if (windowWidth > 800) {
          $('.no-touch .pageContainer').booklet('option', {
            arrows : true
          });
          $('.touch .pageContainer').booklet('option', {
            arrows : false
          });
        } else {
          $('.touch .pageContainer').booklet('option', {
            arrows : false
          });
          $('.no-touch .pageContainer').booklet('option', {
            arrows : false
          });
        }
        // singlezoom
        $('.pageContainer').off('click', '.b-page');
        if ($('.bookContainer').hasClass('singleZoomActive') == true && windowWidth < 800) {
          $('.pageContainer').on('click', '.b-page', function(e) { $
            if ($(this).closest('.tx-flipbook').parent().hasClass('flipbookSinglePage')) {
              singleZoom($(this));
            }
          });
        }
      });

      // sets the flipbook to the parentElement width
      function init() {
          bookWidth = $('.tx-flipbook').width();
          ratio = ($('.tx-flipbook .b-page img').first().width() / $('.tx-flipbook .b-page img').first().height());
          bookHeight = Math.floor((bookWidth / ratio) / 2);
          $('.pageContainer').booklet('option', {
              width : bookWidth,
              height : bookHeight
          });
        $('.pageContainer .b-page img').height(bookHeight);
      }

      // sets the flipbook to fullscreen
      function flipBookZoom(windowWidth, windowHeight) {
        if ($('.tx-flipbook').parent().hasClass('flipbookZoom')) {
          if (windowWidth > 800) {
            bookWidth = windowWidth * 0.6;
          } else {
            bookWidth = windowWidth * 0.95;
          }
          if ($('.tx-flipbook').parent().hasClass('flipbookSinglePage') || $('.tx-flipbook').parent().hasClass('flipbookPageIndex') && $('.tx-flipbook').parent().hasClass('flipbookSinglePage')) {
            bookHeight = parseInt(windowHeight - $('.tx-flipbook .buttons').outerHeight());
          }
          if ($('.tx-flipbook').parent().hasClass('flipbookDoublePage') || $('.tx-flipbook').parent().hasClass('flipbookPageIndex') && $('.tx-flipbook').parent().hasClass('flipbookDoublePage')) {
            bookHeight = parseInt(windowHeight - $('.tx-flipbook .buttons').outerHeight());
            bookWidth = Math.floor(bookHeight * ratio * 2);
            if (bookWidth > windowWidth) {
              bookWidth = windowWidth * 0.9;
              bookHeight = Math.floor((bookWidth / ratio) / 2);
            }
          }

          $('.pageContainer').booklet('option', {
            width : bookWidth,
            height : bookHeight
          });
          setTimeout(function() {
            $('.pageContainer .b-controls > div').height(bookHeight);
            //safari img height/width bugfix...
            $('.pageContainer .b-page img').height(bookHeight);
          }, 1000);
        } else {
          init();
        }
      }

      // moves the singlePage according to the parameter
      function singlePageMove(pageNumber, keepoldpage) {
        var offSet = 0;
        var lastPage = parseInt($('.bookContainer').attr('data-lastpage'));
        if (pageNumber > totalPages)
          pageNumber = totalPages;
        if (pageNumber < 1)
          pageNumber = 1;
        if (keepoldpage) {
          if (pageNumber + 1 == lastPage && pageNumber % 2 == 0)
            pageNumber = lastPage;
        }
        $('.bookContainer').attr('data-lastpage', pageNumber);
        getAmount = pageNumber - 1;
        offSet = getAmount * $('.tx-flipbook .b-page img').first().outerHeight();
        $('.bookContainer').animate({
          scrollTop : offSet
        }, 2000);
        return false;
      }

      function singleZoom(element) {
        element.children().children().toggleClass('singleZoom');
        $(window).resize();
      }

    });
  }(jQuery));
